Project JEDI - Issue Tracker
Mantis Bugtracker

Viewing Issue Simple Details Jump to Notes ] View Advanced ] Issue History ] Print ]
ID Category Severity Reproducibility Date Submitted Last Update
0006182 [JEDI VCL] 00 JVCL Components major sometimes 2013-08-16 14:18 2015-09-14 13:20
Reporter altaveron View Status public  
Assigned To obones
Priority normal Resolution fixed  
Status resolved   Product Version 3.47
Summary 0006182: Incorrect drawing on TJvDBGrid's title after mouse cursor
Description Steps to reproduce:

1. Open a form with TJvDBGrid and columns.
2. Move mouse cursor along grid's title slowly from the left to the right.

Actual Result:

Some borders between grid's title buttons will have incorrect drawing. Some of them - partially. Look to the screenshot.

Expected Result:

All works fine.
Additional Information
Tags No tags attached.
Attached Files png file icon issue.png [^] (6,585 bytes) 2013-08-16 14:23
zip file icon Demo.zip [^] (83,813 bytes) 2013-08-16 16:02
png file icon xp_duplicated_border_issue.png [^] (8,206 bytes) 2013-08-21 20:13
png file icon first_row_indicator_issue.png [^] (11,594 bytes) 2013-08-21 20:14
png file icon devexpress.png [^] (6,746 bytes) 2013-08-21 20:14

- Relationships
related to 0006091resolvedobones Incorrect background of the image on the grid indicator column 
has duplicate 0006183resolvedobones Incorrect drawing on TJvDBGrid's title after mouse cursor 

-  Notes
(0020579)
altaveron (reporter)
2013-08-16 14:22

The was an error 0006184 while adding this issue. So duplicate issue 0006183 were added.
(0020580)
altaveron (reporter)
2013-08-16 15:40

Operation System is Windows 7 x64 with Aero. XP theme on the application is enabled.
(0020590)
altaveron (reporter)
2013-08-21 20:13

There are more issues on TJvDBGrid drawing. Please include all the following changes to the official release.

***INITIAL ISSUE 0000001*** Fix described incorrect behaviour of title cells on Windows 7 and Windows XP.

Replace:

        DrawInfo.Vert.EffectiveLineWidth;
    end;
  end;

  procedure DrawExpandBtn(var TitleRect, TextRect: TRect; InBiDiMode: Boolean;

To:

        DrawInfo.Vert.EffectiveLineWidth;
    end;
    Result.Left := Result.Left + 1;
    if Win32MajorVersion >= 6 then // Windows 7+
      Result.Right := Result.Right - 1;
  end;

  procedure DrawExpandBtn(var TitleRect, TextRect: TRect; InBiDiMode: Boolean;

And replace:

      if TitleRect.Right < ARect.Right then
        TitleRect.Right := ARect.Right;

To:

      if Win32MajorVersion >= 6 then // Windows 7+
        if TitleRect.Right < ARect.Right - 1 then
          TitleRect.Right := ARect.Right - 1
        else
      else
        if TitleRect.Right < ARect.Right then
          TitleRect.Right := ARect.Right;

***ISSUE #2*** Fix excess dark blue border inside sorted title cell (use Windows 7 Aero to reproduce the issue):

Replace:

            DrawCellBackground(Rect(TextRect.Right, TitleRect.Top, TitleRect.Right, TitleRect.Bottom), FixedColor, AState, ACol, ARow - TitleOffset);

To:

            //DrawCellBackground(Rect(TextRect.Right, TitleRect.Top, TitleRect.Right, TitleRect.Bottom), FixedColor, AState, ACol, ARow - TitleOffset);

***ISSUE #3*** There is a duplicated border on Windows XP on indicator cells (see "xp_duplicated_border_issue.png" screenshot). No fix presents.

***ISSUE 0000004*** There is incorrect highlighting of the indicator cell on the first row (see "first_row_indicator_issue.png"). No fix presents.

***ISSUE 0000005*** If you want to improve TJvDBGrid more. Will be better to add to the right of selected title cell the same dark blue border as on the left - like on DevExpress grids (look to the screenshot 'devexpress.png'). Also there is a strange 1px line on upper of the title cell on TJvDBGrid.

All changes were already checked on Windows 7 Aero, Classic themes, Windows XP, XP and Classic themes. Need to check it when COMPILER14_UP is not defined.
(0020591)
altaveron (reporter)
2013-08-21 20:15

Linked issue: 0006091
(0020821)
obones (administrator)
2013-12-13 14:51

Could you please check with latest GIT content, your changes do not fix anything here.
If you find a good fix, please send a pull request on GitHub.
(0020823)
obones (administrator)
2013-12-13 15:03

Forget about that, your project was linking runtime packages which did not allow for easy debugging.
(0020824)
obones (administrator)
2013-12-13 15:03

First and second are now in GIT please create other issues for the three others, along with demo project and proposed fix

- Issue History
Date Modified Username Field Change
2013-08-16 14:18 altaveron New Issue
2013-08-16 14:22 altaveron Note Added: 0020579
2013-08-16 14:22 altaveron Issue Monitored: altaveron
2013-08-16 14:23 altaveron File Added: issue.png
2013-08-16 15:40 altaveron Note Added: 0020580
2013-08-16 16:02 altaveron File Added: Demo.zip
2013-08-21 20:13 altaveron Note Added: 0020590
2013-08-21 20:13 altaveron File Added: xp_duplicated_border_issue.png
2013-08-21 20:14 altaveron File Added: first_row_indicator_issue.png
2013-08-21 20:14 altaveron File Added: devexpress.png
2013-08-21 20:15 altaveron Note Added: 0020591
2013-12-13 11:01 obones Status new => acknowledged
2013-12-13 11:05 obones Relationship added has duplicate 0006183
2013-12-13 14:43 obones Relationship added related to 0006091
2013-12-13 14:51 obones Note Added: 0020821
2013-12-13 14:51 obones Status acknowledged => feedback
2013-12-13 15:03 obones Note Added: 0020823
2013-12-13 15:03 obones Note Added: 0020824
2013-12-13 15:03 obones Status feedback => resolved
2013-12-13 15:03 obones Fixed in Version => Daily / GIT
2013-12-13 15:03 obones Resolution open => fixed
2013-12-13 15:03 obones Assigned To => obones
2014-03-27 22:15 altaveron Issue End Monitor: altaveron
2015-09-14 13:20 obones Fixed in Version Daily / GIT => 3.48


Mantis 1.1.6[^]
Copyright © 2000 - 2008 Mantis Group
Powered by Mantis Bugtracker